diff --git a/src/odbc/unittests/funccall.c b/src/odbc/unittests/funccall.c
index bf80de9..d5a1323 100644
--- a/src/odbc/unittests/funccall.c
+++ b/src/odbc/unittests/funccall.c
@@ -2,7 +2,7 @@
 
 /* Test for {?=call store(?)} syntax and run */
 
-static char software_version[] = "$Id: funccall.c,v 1.15 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: funccall.c,v 1.16 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -19,16 +19,15 @@ main(int argc, char *argv[])
 
 	Command(Statement, "create proc simpleresult @i int as begin return @i end");
 
-	CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &input, 0, &ind2));
+	CHKBindParameter(2, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &input, 0, &ind2, "S");
+	CHKBindParameter(1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind, "S");
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind));
-
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "{ \n?\t\r= call simpleresult(?)}", SQL_NTS));
+	CHKPrepare((SQLCHAR *) "{ \n?\t\r= call simpleresult(?)}", SQL_NTS, "S");
 
 	input = 123;
 	ind2 = sizeof(input);
 	output = 0xdeadbeef;
-	CHK(SQLExecute, (Statement));
+	CHKExecute("S");
 
 	if (output != 123) {
 		printf("Invalid result\n");
@@ -48,7 +47,7 @@ main(int argc, char *argv[])
 	input = 567;
 	ind2 = sizeof(input);
 	output = 0xdeadbeef;
-	CHK(SQLExecDirect, (Statement, (SQLCHAR *) "{?=call simpleresult(?)}", SQL_NTS));
+	CHKExecDirect((SQLCHAR *) "{?=call simpleresult(?)}", SQL_NTS, "S");
 
 	if (output != 567) {
 		fprintf(stderr, "Invalid result\n");
@@ -56,10 +55,7 @@ main(int argc, char *argv[])
 	}
 
 	/* should return "Invalid cursor state" */
-	if (SQLFetch(Statement) != SQL_ERROR) {
-		fprintf(stderr, "Data not expected\n");
-		exit(1);
-	}
+	CHKFetch("E");
 
 	Command(Statement, "drop proc simpleresult");
 
@@ -72,12 +68,12 @@ main(int argc, char *argv[])
 	Command(Statement,
 		"create proc simpleresult2 @i int, @x int output, @y varchar(20) output as begin select @x = 6789 select @y = 'test foo' return @i end");
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0,  0, &output, 0,            &ind));
-	CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_INPUT,  SQL_C_SLONG, SQL_INTEGER, 0,  0, &input,  0,            &ind2));
-	CHK(SQLBindParameter, (Statement, 3, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0,  0, &out1,   0,            &ind3));
-	CHK(SQLBindParameter, (Statement, 4, SQL_PARAM_OUTPUT, SQL_C_CHAR,  SQL_VARCHAR, 20, 0, out2,    sizeof(out2), &ind4));
+	CHKBindParameter(1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0,  0, &output, 0,            &ind,  "S");
+	CHKBindParameter(2, SQL_PARAM_INPUT,  SQL_C_SLONG, SQL_INTEGER, 0,  0, &input,  0,            &ind2, "S");
+	CHKBindParameter(3, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0,  0, &out1,   0,            &ind3, "S");
+	CHKBindParameter(4, SQL_PARAM_OUTPUT, SQL_C_CHAR,  SQL_VARCHAR, 20, 0, out2,    sizeof(out2), &ind4, "S");
 
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "{ \n?\t\r= call simpleresult2(?,?,?)}", SQL_NTS));
+	CHKPrepare((SQLCHAR *) "{ \n?\t\r= call simpleresult2(?,?,?)}", SQL_NTS, "S");
 
 	input = 987;
 	ind2 = sizeof(input);
@@ -85,7 +81,7 @@ main(int argc, char *argv[])
 	output = 0xdeadbeef;
 	ind3 = SQL_DATA_AT_EXEC;
 	ind4 = SQL_DEFAULT_PARAM;
-	CHK(SQLExecute, (Statement));
+	CHKExecute("S");
 
 	if (output != 987 || ind3 <= 0 || ind4 <= 0 || out1 != 6789 || strcmp(out2, "test foo") != 0) {
 		printf("ouput = %d ind3 = %d ind4 = %d out1 = %d out2 = %s\n", (int) output, (int) ind3, (int) ind4, (int) out1,
@@ -114,23 +110,22 @@ main(int argc, char *argv[])
 	Command(Statement, "create proc rpc_read @i int, @x timestamp as begin select 1 return 1234 end");
 	SQLCloseCursor(Statement);
 
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "{ ? = CALL rpc_read ( ?, ? ) }" , SQL_NTS));
+	CHKPrepare((SQLCHAR *) "{ ? = CALL rpc_read ( ?, ? ) }" , SQL_NTS, "S");
 
 	ind = 0;
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &output, 0, &ind));
+	CHKBindParameter(1, SQL_PARAM_OUTPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &output, 0, &ind, "S");
 
 	ind2 = 0;
-	CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &input, 0, &ind2));
+	CHKBindParameter(2, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &input, 0, &ind2, "S");
 
 	ind3 = 8;
-	CHK(SQLBindParameter, (Statement, 3, SQL_PARAM_INPUT, SQL_C_BINARY, SQL_VARBINARY, 8, 0, out2, 8, &ind3));
+	CHKBindParameter(3, SQL_PARAM_INPUT, SQL_C_BINARY, SQL_VARBINARY, 8, 0, out2, 8, &ind3, "S");
 
-	CHK(SQLExecute, (Statement));
+	CHKExecute("S");
 
-	CHK(SQLFetch, (Statement));
+	CHKFetch("S");
 
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Data not expected\n");
+	CHKFetch("No");
 
 	ResetStatement();
 	Command(Statement, "drop proc rpc_read");
@@ -151,11 +146,11 @@ main(int argc, char *argv[])
 
 		ResetStatement();
 
-		CHK(SQLPrepare, (Statement, (SQLCHAR *) "{ call sp_test(?)}", SQL_NTS));
-		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind));
+		CHKPrepare((SQLCHAR *) "{ call sp_test(?)}", SQL_NTS, "S");
+		CHKBindParameter(1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind, "S");
 
 		output = 0xdeadbeef;
-		CHK(SQLExecute, (Statement));
+		CHKExecute("S");
 
 		if (output != 456) {
 			fprintf(stderr, "Invalid result %d(%x)\n", (int) output, (int) output);
diff --git a/src/odbc/unittests/genparams.c b/src/odbc/unittests/genparams.c
index 7f8c9b6..bb0b542 100644
--- a/src/odbc/unittests/genparams.c
+++ b/src/odbc/unittests/genparams.c
@@ -18,7 +18,7 @@
  * Also we have to check normal char and wide char
  */
 
-static char software_version[] = "$Id: genparams.c,v 1.36 2008/10/29 09:33:50 freddy77 Exp $";
+static char software_version[] = "$Id: genparams.c,v 1.37 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef TDS_NO_DM
@@ -55,28 +55,28 @@ TestOutput(const char *type, const char *value_to_convert, SQLSMALLINT out_c_typ
 
 	if (use_cursors) {
 		ResetStatement();
-		CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_SCROLLABLE, 0));
-		CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_TYPE, (SQLPOINTER) SQL_CURSOR_DYNAMIC, 0));
+		CHKSetStmtAttr(SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_SCROLLABLE, 0, "S");
+		CHKSetStmtAttr(SQL_ATTR_CURSOR_TYPE, (SQLPOINTER) SQL_CURSOR_DYNAMIC, 0, "S");
 	}
 
 	/* bind parameter */
 	if (exec_direct) {
-		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, out_c_type, out_sql_type, precision, 0, out_buf,
-			     sizeof(out_buf), &out_len));
+		CHKBindParameter(1, SQL_PARAM_OUTPUT, out_c_type, out_sql_type, precision, 0, out_buf,
+			     sizeof(out_buf), &out_len, "S");
 
 		/* call store procedure */
-		CHK(SQLExecDirect, (Statement, (SQLCHAR *) "{call spTestProc(?)}", SQL_NTS));
+		CHKExecDirect((SQLCHAR *) "{call spTestProc(?)}", SQL_NTS, "S");
 	} else {
 		if (prepare_before)
-			CHK(SQLPrepare, (Statement, (SQLCHAR *) "{call spTestProc(?)}", SQL_NTS));
+			CHKPrepare((SQLCHAR *) "{call spTestProc(?)}", SQL_NTS, "S");
 
-		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, out_c_type, out_sql_type, precision, 0, out_buf,
-			     sizeof(out_buf), &out_len));
+		CHKBindParameter(1, SQL_PARAM_OUTPUT, out_c_type, out_sql_type, precision, 0, out_buf,
+			     sizeof(out_buf), &out_len, "S");
 
 		if (!prepare_before)
-			CHK(SQLPrepare, (Statement, (SQLCHAR *) "{call spTestProc(?)}", SQL_NTS));
+			CHKPrepare((SQLCHAR *) "{call spTestProc(?)}", SQL_NTS, "S");
 
-		CHK(SQLExecute, (Statement));
+		CHKExecute("S");
 	}
 
 	/* test results */
@@ -137,12 +137,9 @@ TestInput(SQLSMALLINT out_c_type, const char *type, SQLSMALLINT out_sql_type, co
 	sprintf(sbuf, "SELECT CONVERT(%s, %s%.*s%s)", type, sep, (int) value_len, value_to_convert, sep);
 	Command(Statement, sbuf);
 	SQLBindCol(Statement, 1, out_c_type, out_buf, sizeof(out_buf), &out_len);
-	if (!SQL_SUCCEEDED(SQLFetch(Statement)))
-		ODBC_REPORT_ERROR("Expected row");
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Row not expected");
-	if (SQLMoreResults(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Recordset not expected");
+	CHKFetch("SI");
+	CHKFetch("No");
+	CHKMoreResults("No");
 	if (use_nts) {
 		out_len = SQL_NTS;
 		use_nts = 0;
@@ -155,40 +152,32 @@ TestInput(SQLSMALLINT out_c_type, const char *type, SQLSMALLINT out_sql_type, co
 
 	if (use_cursors) {
 		ResetStatement();
-		CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_SCROLLABLE, 0));
-		CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_TYPE, (SQLPOINTER) SQL_CURSOR_DYNAMIC, 0));
+		CHKSetStmtAttr(SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_SCROLLABLE, 0, "S");
+		CHKSetStmtAttr(SQL_ATTR_CURSOR_TYPE, (SQLPOINTER) SQL_CURSOR_DYNAMIC, 0, "S");
 	}
 
 	/* insert data using prepared statements */
 	sprintf(sbuf, "INSERT INTO #tmp_insert VALUES(?)");
 	if (exec_direct) {
-		SQLRETURN rc;
+		CHKBindParameter(1, SQL_PARAM_INPUT, out_c_type, out_sql_type, 20, 0, out_buf, sizeof(out_buf), &out_len, "S");
 
-		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, out_c_type, out_sql_type, 20, 0, out_buf, sizeof(out_buf), &out_len));
-
-		rc = SQLExecDirect(Statement, (SQLCHAR *) sbuf, SQL_NTS);
-		if (check_truncation) {
-			if (rc != SQL_ERROR)
-				ODBC_REPORT_ERROR("SQLExecDirect should return error!");
-		} else if (rc != SQL_SUCCESS && rc != SQL_NO_DATA)
-			ODBC_REPORT_ERROR("SQLExecDirect() failure!");
+		if (check_truncation)
+			CHKExecDirect((SQLCHAR *) sbuf, SQL_NTS, "E");
+		else
+			CHKExecDirect((SQLCHAR *) sbuf, SQL_NTS, "SNo");
 	} else {
-		SQLRETURN rc;
-
 		if (prepare_before)
-			CHK(SQLPrepare, (Statement, (SQLCHAR *) sbuf, SQL_NTS));
+			CHKPrepare((SQLCHAR *) sbuf, SQL_NTS, "S");
 
-		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, out_c_type, out_sql_type, 20, 0, out_buf, sizeof(out_buf), &out_len));
+		CHKBindParameter(1, SQL_PARAM_INPUT, out_c_type, out_sql_type, 20, 0, out_buf, sizeof(out_buf), &out_len, "S");
 
 		if (!prepare_before)
-			CHK(SQLPrepare, (Statement, (SQLCHAR *) sbuf, SQL_NTS));
-
-		rc = SQLExecute(Statement);
-		if (check_truncation) {
-			if (rc != SQL_ERROR)
-				ODBC_REPORT_ERROR("SQLExecute should return error!");
-		} else if (rc != SQL_SUCCESS && rc != SQL_NO_DATA)
-			ODBC_REPORT_ERROR("SQLExecute() failure!");
+			CHKPrepare((SQLCHAR *) sbuf, SQL_NTS, "S");
+
+		if (check_truncation)
+			CHKExecute("E");
+		else
+			CHKExecute("SNo");
 	}
 
 	/* check is row is present */
@@ -200,11 +189,9 @@ TestInput(SQLSMALLINT out_c_type, const char *type, SQLSMALLINT out_sql_type, co
 		sprintf(sbuf, "SELECT * FROM #tmp_insert WHERE col = CONVERT(%s, %s%s%s)", param_type, sep, expected, sep);
 		Command(Statement, sbuf);
 
-		CHK(SQLFetch, (Statement));
-		if (SQLFetch(Statement) != SQL_NO_DATA)
-			ODBC_REPORT_ERROR("Row not expected");
-		if (SQLMoreResults(Statement) != SQL_NO_DATA)
-			ODBC_REPORT_ERROR("Recordset not expected");
+		CHKFetch("S");
+		CHKFetch("No");
+		CHKMoreResults("No");
 	}
 	check_truncation = 0;
 	Command(Statement, "DROP TABLE #tmp_insert");
diff --git a/src/odbc/unittests/getdata.c b/src/odbc/unittests/getdata.c
index d827e42..b570f7a 100644
--- a/src/odbc/unittests/getdata.c
+++ b/src/odbc/unittests/getdata.c
@@ -1,7 +1,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: getdata.c,v 1.8 2008/10/27 14:23:23 freddy77 Exp $";
+static char software_version[] = "$Id: getdata.c,v 1.9 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char odbc_err[256];
@@ -12,17 +12,8 @@ ReadError(void)
 {
 	memset(odbc_err, 0, sizeof(odbc_err));
 	memset(odbc_sqlstate, 0, sizeof(odbc_sqlstate));
-	if (!SQL_SUCCEEDED(SQLGetDiagRec(SQL_HANDLE_STMT
-					, Statement
-					, 1
-					, (SQLCHAR *) odbc_sqlstate
-					, NULL
-					, (SQLCHAR *) odbc_err
-					, sizeof(odbc_err)
-					, NULL))) {
-		printf("SQLGetDiagRec should not fail\n");
-		exit(1);
-	}
+	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, (SQLCHAR *) odbc_sqlstate,
+		      NULL, (SQLCHAR *) odbc_err, sizeof(odbc_err), NULL, "SI");
 	printf("Message: '%s' %s\n", odbc_sqlstate, odbc_err);
 }
 
@@ -30,7 +21,6 @@ static void
 test_err(const char *data, int c_type, const char *state)
 {
 	char sql[128];
-	SQLRETURN rc;
 	SQLLEN ind;
 	const unsigned int buf_size = 128;
 	char *buf = (char *) malloc(buf_size);
@@ -38,10 +28,8 @@ test_err(const char *data, int c_type, const char *state)
 	sprintf(sql, "SELECT '%s'", data);
 	Command(Statement, sql);
 	SQLFetch(Statement);
-	rc = SQLGetData(Statement, 1, c_type, buf, buf_size, &ind);
+	CHKGetData(1, c_type, buf, buf_size, &ind, "E");
 	free(buf);
-	if (rc != SQL_ERROR)
-		ODBC_REPORT_ERROR("SQLGetData error expected");
 	ReadError();
 	if (strcmp(odbc_sqlstate, state) != 0) {
 		fprintf(stderr, "Unexpected sql state returned\n");
@@ -89,23 +77,18 @@ main(int argc, char *argv[])
 		/* TODO test with VARCHAR too */
 		Command(Statement, "SELECT CONVERT(TEXT,'Prova')");
 
-		CHK(SQLFetch, (Statement));
+		CHKFetch("S");
 
 		/* these 2 tests test an old severe BUG in FreeTDS */
-		if (SQLGetData(Statement, 1, type, buf, 0, NULL) != SQL_SUCCESS_WITH_INFO)
-			ODBC_REPORT_ERROR("Unable to get data");
-
-		if (SQLGetData(Statement, 1, type, buf, 0, NULL) != SQL_SUCCESS_WITH_INFO)
-			ODBC_REPORT_ERROR("Unable to get data");
-
-		if (SQLGetData(Statement, 1, type, buf, 3 * lc, NULL) != SQL_SUCCESS_WITH_INFO)
-			ODBC_REPORT_ERROR("Unable to get data");
+		CHKGetData(1, type, buf, 0, NULL, "I");
+		CHKGetData(1, type, buf, 0, NULL, "I");
+		CHKGetData(1, type, buf, 3 * lc, NULL, "I");
 		if (mycmp(buf, "Pr") != 0) {
 			printf("Wrong data result 1\n");
 			exit(1);
 		}
 
-		CHK(SQLGetData, (Statement, 1, type, buf, 16, NULL));
+		CHKGetData(1, type, buf, 16, NULL, "S");
 		if (mycmp(buf, "ova") != 0) {
 			printf("Wrong data result 2 res = '%s'\n", buf);
 			exit(1);
@@ -116,16 +99,15 @@ main(int argc, char *argv[])
 		/* test with varchar, not blob but variable */
 		Command(Statement, "SELECT CONVERT(VARCHAR(100), 'Other test')");
 
-		CHK(SQLFetch, (Statement));
+		CHKFetch("S");
 
-		if (SQLGetData(Statement, 1, type, buf, 7 * lc, NULL) != SQL_SUCCESS_WITH_INFO)
-			ODBC_REPORT_ERROR("Unable to get data");
+		CHKGetData(1, type, buf, 7 * lc, NULL, "I");
 		if (mycmp(buf, "Other ") != 0) {
 			printf("Wrong data result 1\n");
 			exit(1);
 		}
 
-		CHK(SQLGetData, (Statement, 1, type, buf, 16, NULL));
+		CHKGetData(1, type, buf, 16, NULL, "S");
 		if (mycmp(buf, "test") != 0) {
 			printf("Wrong data result 2 res = '%s'\n", buf);
 			exit(1);
@@ -143,17 +125,16 @@ main(int argc, char *argv[])
 	/* test with fixed length */
 	Command(Statement, "SELECT CONVERT(INT, 12345)");
 
-	CHK(SQLFetch, (Statement));
+	CHKFetch("S");
 
 	int_buf = 0xdeadbeef;
-	CHK(SQLGetData, (Statement, 1, SQL_C_SLONG, &int_buf, 0, NULL));
+	CHKGetData(1, SQL_C_SLONG, &int_buf, 0, NULL, "S");
 	if (int_buf != 12345) {
 		printf("Wrong data result\n");
 		exit(1);
 	}
 
-	if (SQLGetData(Statement, 1, SQL_C_SLONG, &int_buf, 0, NULL) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Unable to get data");
+	CHKGetData(1, SQL_C_SLONG, &int_buf, 0, NULL, "No");
 	if (int_buf != 12345) {
 		printf("Wrong data result 2 res = %d\n", (int) int_buf);
 		exit(1);
@@ -186,18 +167,17 @@ main(int argc, char *argv[])
 		for (;;) {
 			Command(Statement, "SELECT CONVERT(TEXT,'')");
 
-			CHK(SQLFetch, (Statement));
+			CHKFetch("S");
 
 			len = 1234;
-			CHK(SQLGetData, (Statement, 1, type, buf, lc, &len));
+			CHKGetData(1, type, buf, lc, &len, "S");
 
 			if (len != 0) {
 				fprintf(stderr, "Wrong len returned, returned %ld\n", (long) len);
 				return 1;
 			}
 
-			if (SQLGetData(Statement, 1, type, buf, lc, NULL) != SQL_NO_DATA)
-				ODBC_REPORT_ERROR("invalid return from SQLGetData");
+			CHKGetData(1, type, buf, lc, NULL, "No");
 			ResetStatement();
 
 			if (type != SQL_C_CHAR)
diff --git a/src/odbc/unittests/hidden.c b/src/odbc/unittests/hidden.c
index a911f10..c106b7b 100755
--- a/src/odbc/unittests/hidden.c
+++ b/src/odbc/unittests/hidden.c
@@ -3,7 +3,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: hidden.c,v 1.5 2008/10/17 12:21:10 freddy77 Exp $";
+static char software_version[] = "$Id: hidden.c,v 1.6 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -23,7 +23,7 @@ main(int argc, char **argv)
 
 	Command(Statement, "SELECT c, b FROM #tmp1");
 
-	CHK(SQLNumResultCols, (Statement, &cnt));
+	CHKNumResultCols(&cnt, "S");
 
 	if (cnt != 2) {
 		fprintf(stderr, "Wrong number of columns in result set: %d\n", (int) cnt);
@@ -34,14 +34,14 @@ main(int argc, char **argv)
 	/* test hidden column with cursors*/
 	CheckCursor();
 
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_NONSCROLLABLE, SQL_IS_UINTEGER));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_SENSITIVITY, (SQLPOINTER) SQL_SENSITIVE, SQL_IS_UINTEGER));
+	CHKSetStmtAttr(SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_NONSCROLLABLE, SQL_IS_UINTEGER, "S");
+	CHKSetStmtAttr(SQL_ATTR_CURSOR_SENSITIVITY, (SQLPOINTER) SQL_SENSITIVE, SQL_IS_UINTEGER, "S");
 
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "SELECT * FROM #t1", SQL_NTS));
+	CHKPrepare((SQLCHAR *) "SELECT * FROM #t1", SQL_NTS, "S");
 
-	CHK(SQLExecute, (Statement));
+	CHKExecute("S");
 
-	CHK(SQLNumResultCols, (Statement, &cnt));
+	CHKNumResultCols(&cnt, "S");
 
 	if (cnt != 3) {
 		fprintf(stderr, "Wrong number of columns in result set: %d\n", (int) cnt);
diff --git a/src/odbc/unittests/insert_speed.c b/src/odbc/unittests/insert_speed.c
index 9e47343..6fa5cbc 100644
--- a/src/odbc/unittests/insert_speed.c
+++ b/src/odbc/unittests/insert_speed.c
@@ -1,7 +1,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: insert_speed.c,v 1.6 2007/11/26 18:12:31 freddy77 Exp $";
+static char software_version[] = "$Id: insert_speed.c,v 1.7 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define SQL_QUERY_LENGTH 80
@@ -10,105 +10,54 @@ static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 /* I don't remember where this test came ... - freddy77 */
 
-static int
+static void
 insert_test_auto(void)
 {
-	SQLHSTMT hstmt = NULL;
 	SQLLEN sql_nts = SQL_NTS;
-	char query[SQL_QUERY_LENGTH];
 	SQLINTEGER id = 0;
 	char string[64];
 
-	if (!SQL_SUCCEEDED(SQLAllocHandle(SQL_HANDLE_STMT, Connection, &hstmt))) {
-		return (-1);
-	}
-
-	strcpy(query, "insert into test values (?, ?)");
-
-	if (!SQL_SUCCEEDED(SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, sizeof(id), 0, &id, 0, &sql_nts))
-	    ||
-	    !SQL_SUCCEEDED(SQLBindParameter
-			   (hstmt, 2, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, sizeof(string), 0, string, 0, &sql_nts))) {
-		SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
-		return (-1);
-	}
+	ResetStatement();
 
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, sizeof(id), 0, &id, 0, &sql_nts, "SI");
+	CHKBindParameter(2, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, sizeof(string), 0, string, 0, &sql_nts, "SI");
 
-	if (!SQL_SUCCEEDED(SQLPrepare(hstmt, (SQLCHAR *) query, SQL_NTS))) {
-		SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
-		return (-1);
-	}
-
+	CHKPrepare((SQLCHAR *) "insert into test values (?, ?)", SQL_NTS, "SI");
 	for (id = 0; id < 20; id++) {
 		sprintf(string, "This is a test (%d)", (int) id);
-		if (!SQL_SUCCEEDED(SQLExecute(hstmt))) {
-			SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
-			return (-1);
-		}
+		CHKExecute("SI");
 	}
 
-	SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
-	return (0);
+	ResetStatement();
 }
 
 
-static int
+static void
 insert_test_man(void)
 {
-	SQLHSTMT hstmt = NULL;
 	SQLLEN sql_nts = SQL_NTS;
 	SQLINTEGER commit_off = SQL_AUTOCOMMIT_OFF;
 	SQLINTEGER commit_on = SQL_AUTOCOMMIT_ON;
-	char query[SQL_QUERY_LENGTH];
 	SQLINTEGER id = 0;
 
 	char string[64];
 
-	if (!SQL_SUCCEEDED(SQLSetConnectAttr(Connection, SQL_ATTR_AUTOCOMMIT, int2ptr(commit_off), SQL_IS_INTEGER))) {
-		fprintf(stderr, "Unable to set autocommit mode\n");
-		return (-1);
-	}
-
-	if (!SQL_SUCCEEDED(SQLAllocHandle(SQL_HANDLE_STMT, Connection, &hstmt))) {
-		fprintf(stderr, "Unable to allocate statement handle\n");
-		return (-1);
-	}
-
-	strcpy(query, "insert into test values (?, ?)");
-
-	if (!SQL_SUCCEEDED(SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, sizeof(id), 0, &id, 0, &sql_nts))
-	    ||
-	    !SQL_SUCCEEDED(SQLBindParameter
-			   (hstmt, 2, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, sizeof(string), 0, string, 0, &sql_nts))) {
-		SQLSetConnectAttr(Connection, SQL_ATTR_AUTOCOMMIT, int2ptr(commit_on), SQL_IS_INTEGER);
-		SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
-		fprintf(stderr, "unable to bind parameters\n");
-		return (-1);
-	}
+	CHKSetConnectAttr(SQL_ATTR_AUTOCOMMIT, int2ptr(commit_off), SQL_IS_INTEGER, "SI");
 
+	ResetStatement();
 
-	if (!SQL_SUCCEEDED(SQLPrepare(hstmt, (SQLCHAR *) query, SQL_NTS))) {
-		SQLSetConnectAttr(Connection, SQL_ATTR_AUTOCOMMIT, int2ptr(commit_on), SQL_IS_INTEGER);
-		SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
-		fprintf(stderr, "Unable to prepare statement\n");
-		return (-1);
-	}
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, sizeof(id), 0, &id, 0, &sql_nts, "SI");
+	CHKBindParameter(2, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, sizeof(string), 0, string, 0, &sql_nts, "SI");
 
+	CHKPrepare((SQLCHAR *) "insert into test values (?, ?)", SQL_NTS, "SI");
 	for (id = 0; id < 20; id++) {
 		sprintf(string, "This is a test (%d)", (int) id);
-		if (!SQL_SUCCEEDED(SQLExecute(hstmt))) {
-			SQLEndTran(SQL_HANDLE_DBC, hstmt, SQL_ROLLBACK);
-			SQLSetConnectAttr(Connection, SQL_ATTR_AUTOCOMMIT, int2ptr(commit_on), SQL_IS_INTEGER);
-			SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
-			fprintf(stderr, "Unable to execute statement %d\n", (int) id);
-			return (-1);
-		}
+		CHKExecute("SI");
 	}
 
 	SQLEndTran(SQL_HANDLE_DBC, Connection, SQL_COMMIT);
 	SQLSetConnectAttr(Connection, SQL_ATTR_AUTOCOMMIT, int2ptr(commit_on), SQL_IS_INTEGER);
-	SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
-	return (0);
+	ResetStatement();
 }
 
 int
@@ -119,13 +68,11 @@ main(int argc, char **argv)
 	CommandWithResult(Statement, "DROP TABLE test");
 	Command(Statement, "CREATE TABLE test(i int, c varchar(40))");
 
-	if (insert_test_man() < 0)
-		return 1;
+	insert_test_man();
 
 	Command(Statement, "DELETE FROM test");
 
-	if (insert_test_auto() < 0)
-		return 1;
+	insert_test_auto();
 
 	Command(Statement, "DROP TABLE test");
 
diff --git a/src/odbc/unittests/lang_error.c b/src/odbc/unittests/lang_error.c
index 90192b4..c974cbd 100644
--- a/src/odbc/unittests/lang_error.c
+++ b/src/odbc/unittests/lang_error.c
@@ -2,7 +2,7 @@
 
 /* Test if SQLExecDirect return error if a error in row is returned */
 
-static char software_version[] = "$Id: lang_error.c,v 1.3 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: lang_error.c,v 1.4 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -11,10 +11,7 @@ main(int argc, char *argv[])
 	Connect();
 
 	/* issue print statement and test message returned */
-	if (CommandWithResult(Statement, "SELECT DATEADD(dd,-100000,getdate())") != SQL_ERROR) {
-		fprintf(stderr, "SQLExecDirect should return SQL_ERROR\n");
-		return 1;
-	}
+	CHKR(CommandWithResult, (Statement, "SELECT DATEADD(dd,-100000,getdate())"), "E");
 
 	Disconnect();
 
diff --git a/src/odbc/unittests/moreandcount.c b/src/odbc/unittests/moreandcount.c
index 95ae329..4ecf7af 100644
--- a/src/odbc/unittests/moreandcount.c
+++ b/src/odbc/unittests/moreandcount.c
@@ -2,34 +2,10 @@
 
 /* Test for SQLMoreResults and SQLRowCount on batch */
 
-static char software_version[] = "$Id: moreandcount.c,v 1.15 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: moreandcount.c,v 1.16 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
-NextResults(SQLRETURN expected, int line)
-{
-	if (SQLMoreResults(Statement) != expected) {
-		if (expected == SQL_SUCCESS)
-			fprintf(stderr, "Expected another recordset line %d\n", line);
-		else
-			fprintf(stderr, "Not expected another recordset line %d\n", line);
-		exit(1);
-	}
-}
-
-static void
-Fetch(SQLRETURN expected)
-{
-	if (SQLFetch(Statement) != expected) {
-		if (expected == SQL_SUCCESS)
-			fprintf(stderr, "Expected another record\n");
-		else
-			fprintf(stderr, "Not expected another record\n");
-		exit(1);
-	}
-}
-
-static void
 DoTest(int prepare)
 {
 	int n = 0;
@@ -45,59 +21,59 @@ DoTest(int prepare)
 		"UPDATE #tmp1 SET i=i+1 WHERE i >= 2";
 
 	if (prepare) {
-		CHK(SQLPrepare, (Statement, (SQLCHAR *) query, SQL_NTS));
-		CHK(SQLExecute, (Statement));
+		CHKPrepare((SQLCHAR *) query, SQL_NTS, "S");
+		CHKExecute("S");
 	} else {
 
 		/* execute a batch command select insert insert select and check rows */
-		CHK(SQLExecDirect, (Statement, (SQLCHAR *) query, SQL_NTS));
+		CHKExecDirect((SQLCHAR *) query, SQL_NTS, "S");
 	}
 	if (!prepare) {
 		printf("Result %d\n", ++n);
 		CHECK_COLS(0);
 		CHECK_ROWS(1);
-		NextResults(SQL_SUCCESS, __LINE__);
+		CHKMoreResults("S");
 	}
 	printf("Result %d\n", ++n);
 	CHECK_COLS(1);
 	CHECK_ROWS(-1);
-	Fetch(SQL_SUCCESS);
-	Fetch(SQL_SUCCESS);
+	CHKFetch("S");
+	CHKFetch("S");
 	CHECK_COLS(1);
 	CHECK_ROWS(-1);
-	Fetch(SQL_NO_DATA);
+	CHKFetch("No");
 	CHECK_COLS(1);
 	CHECK_ROWS(2);
-	NextResults(SQL_SUCCESS, __LINE__);
+	CHKMoreResults("S");
 	if (!prepare) {
 		printf("Result %d\n", ++n);
 		CHECK_COLS(0);
 		CHECK_ROWS(1);
-		NextResults(SQL_SUCCESS, __LINE__);
+		CHKMoreResults("S");
 		printf("Result %d\n", ++n);
 		CHECK_COLS(0);
 		CHECK_ROWS(2);
-		NextResults(SQL_SUCCESS, __LINE__);
+		CHKMoreResults("S");
 	}
 	printf("Result %d\n", ++n);
 	CHECK_COLS(1);
 	CHECK_ROWS(-1);
-	Fetch(SQL_SUCCESS);
+	CHKFetch("S");
 	CHECK_COLS(1);
 	CHECK_ROWS(-1);
-	Fetch(SQL_NO_DATA);
+	CHKFetch("No");
 	CHECK_COLS(1);
 	if (prepare) {
 		/* collapse 2 recordset... after a lot of testing this is the behavior! */
 		CHECK_ROWS(2);
 	} else {
 		CHECK_ROWS(1);
-		NextResults(SQL_SUCCESS, __LINE__);
+		CHKMoreResults("S");
 		CHECK_COLS(0);
 		CHECK_ROWS(2);
 	}
 
-	NextResults(SQL_NO_DATA, __LINE__);
+	CHKMoreResults("No");
 #ifndef TDS_NO_DM
 	if (!prepare)
 		CHECK_COLS(-1);
diff --git a/src/odbc/unittests/norowset.c b/src/odbc/unittests/norowset.c
index b18245c..9a2117d 100644
--- a/src/odbc/unittests/norowset.c
+++ b/src/odbc/unittests/norowset.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: norowset.c,v 1.6 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: norowset.c,v 1.7 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 /* Test that a select following a store procedure execution return results */
@@ -8,7 +8,6 @@ static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 int
 main(int argc, char *argv[])
 {
-	int res;
 	char output[256];
 	SQLLEN dataSize;
 
@@ -22,25 +21,18 @@ main(int argc, char *argv[])
 
 	/* note, mssql 2005 seems to not return row for tempdb, use always master */
 	Command(Statement, "select name from master..sysobjects where name = 'sysobjects'");
-	CHK(SQLFetch, (Statement));
+	CHKFetch("S");
 
-	CHK(SQLGetData, (Statement, 1, SQL_C_CHAR, output, sizeof(output), &dataSize));
+	CHKGetData(1, SQL_C_CHAR, output, sizeof(output), &dataSize, "S");
 
 	if (strcmp(output, "sysobjects") != 0) {
 		printf("Unexpected result\n");
 		exit(1);
 	}
 
-	res = SQLFetch(Statement);
-	if (res != SQL_NO_DATA) {
-		fprintf(stderr, "Row not expected\n");
-		CheckReturn();
-	}
+	CHKFetch("No");
 
-	if (SQLMoreResults(Statement) != SQL_NO_DATA) {
-		fprintf(stderr, "Not expected another recordset\n");
-		exit(1);
-	}
+	CHKMoreResults("No");
 
 	Command(Statement, "drop proc sp_norowset_test");
 
diff --git a/src/odbc/unittests/paramcore.c b/src/odbc/unittests/paramcore.c
index 0addd1f..5d69ae3 100644
--- a/src/odbc/unittests/paramcore.c
+++ b/src/odbc/unittests/paramcore.c
@@ -4,7 +4,7 @@
  * Try to make core dump using SQLBindParameter
  */
 
-static char software_version[] = "$Id: paramcore.c,v 1.4 2006/07/25 08:11:00 freddy77 Exp $";
+static char software_version[] = "$Id: paramcore.c,v 1.5 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define SP_TEXT "{call sp_paramcore_test(?)}"
@@ -29,7 +29,6 @@ ReadError(void)
 int
 main(int argc, char *argv[])
 {
-	SQLRETURN rc;
 	SQLLEN cb = SQL_NTS;
 
 	use_odbc_version3 = 1;
@@ -40,20 +39,20 @@ main(int argc, char *argv[])
 	Command(Statement, "create proc sp_paramcore_test @s varchar(100) output as select @s = '12345'");
 
 	/* here we pass a NULL buffer for input SQL_NTS */
-	rc = SQLBindParameter(Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, OUTSTRING_LEN, 0, NULL, OUTSTRING_LEN, &cb);
+	SQLBindParameter(Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, OUTSTRING_LEN, 0, NULL, OUTSTRING_LEN, &cb);
 	ReadError();
 
 	cb = SQL_NTS;
-	rc = CommandWithResult(Statement, SP_TEXT);
+	CommandWithResult(Statement, SP_TEXT);
 	ReadError();
 	ResetStatement();
 
 	/* here we pass a NULL buffer for input */
-	rc = SQLBindParameter(Statement, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_VARCHAR, 18, 0, NULL, OUTSTRING_LEN, &cb);
+	SQLBindParameter(Statement, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_VARCHAR, 18, 0, NULL, OUTSTRING_LEN, &cb);
 	ReadError();
 
 	cb = 1;
-	rc = CommandWithResult(Statement, SP_TEXT);
+	CommandWithResult(Statement, SP_TEXT);
 	ReadError();
 	ResetStatement();
 
@@ -64,11 +63,11 @@ main(int argc, char *argv[])
 #if 0	/* this fails even on native platforms */
 	/* here we pass a NULL buffer for output */
 	cb = sizeof(SQL_NUMERIC_STRUCT);
-	rc = SQLBindParameter(Statement, 1, SQL_PARAM_OUTPUT, SQL_C_NUMERIC, SQL_NUMERIC, 18, 0, NULL, OUTSTRING_LEN, &cb);
+	SQLBindParameter(Statement, 1, SQL_PARAM_OUTPUT, SQL_C_NUMERIC, SQL_NUMERIC, 18, 0, NULL, OUTSTRING_LEN, &cb);
 	ReadError();
 
 	cb = 1;
-	rc = CommandWithResult(Statement, SP_TEXT);
+	CommandWithResult(Statement, SP_TEXT);
 	ReadError();
 	ResetStatement();
 #endif
